function isDef(val){return typeof val!="undefined"}
function isNull(val){return val===null}
function isString(val){return typeof val=="string"}
var getHashCode;var removeHashCode;(function(){var hashCodeProperty="lang_hashCode_";getHashCode=function(obj){if(!obj[hashCodeProperty]){obj[hashCodeProperty]=++getHashCode.hashCodeCounter_}return obj[hashCodeProperty]}
;removeHashCode=function(obj){obj[hashCodeProperty]=undefined}
;getHashCode.hashCodeCounter_=0}
)();String.prototype.startsWith=function(prefix){if(this.length<prefix.length){return false}if(this.substring(0,prefix.length)==prefix){return true}return false}
;String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g,"")}
;String.prototype.subs=function(){var ret=this;for(var i=0;i<arguments.length;i++){ret=ret.replace(/\%s/,String(arguments[i]))}return ret}
;if(!Function.prototype.apply){Function.prototype.apply=function(oScope,args){var sarg=[];var rtrn,call;if(!oScope)oScope=window;if(!args)args=[];for(var i=0;i<args.length;i++){sarg[i]="args["+i+"]"}call="oScope.__applyTemp__.peek().("+sarg.join(",")+");";if(!oScope.__applyTemp__){oScope.__applyTemp__=[]}oScope.__applyTemp__.push(this);rtrn=eval(call);oScope.__applyTemp__.pop();return rtrn}
}if(!Array.prototype.push){Array.prototype.push=function(){for(var i=0;i<arguments.length;i++){this[this.length]=arguments[i]}return this.length}
}if(!Array.prototype.pop){Array.prototype.pop=function(){if(!this.length){return}var val=this[this.length-1];this.length--;return val}
}Array.prototype.peek=function(){return this[this.length-1]}
;if(!Array.prototype.shift){Array.prototype.shift=function(){if(this.length==0){return}var val=this[0];for(var i=0;i<this.length-1;i++){this[i]=this[i+1]}this.length--;return val}
}if(!Array.prototype.unshift){Array.prototype.unshift=function(){var numArgs=arguments.length;for(var i=this.length-1;i>=0;i--){this[i+numArgs]=this[i]}for(var j=0;j<numArgs;j++){this[j]=arguments[j]}return this.length}
}if(!Array.prototype.forEach){Array.prototype.forEach=function(callback,scope){for(var i=0;i<this.length;i++){callback.apply(scope,[this[i]])}}
}function bind(fn,self,opt_args){var boundargs=fn.boundArgs_||[];boundargs=boundargs.concat(Array.prototype.slice.call(arguments,2));if(typeof fn.boundSelf_!="undefined"){self=fn.boundSelf_}if(typeof fn.foundFn_!="undefined"){fn=fn.boundFn_}var newfn=function(){var args=boundargs.concat(Array.prototype.slice.call(arguments));return fn.apply(self,args)}
;newfn.boundArgs_=boundargs;newfn.boundSelf_=self;newfn.boundFn_=fn;return newfn}
Function.prototype.bind=function(self,opt_args){return bind.apply(null,[this,self].concat(Array.prototype.slice.call(arguments,1)))}
;Function.prototype.partial=function(opt_args){return bind.apply(null,[this,null].concat(Array.prototype.slice.call(arguments)))}
;Function.prototype.inherits=function(parentCtor){var tempCtor=function(){}
;tempCtor.prototype=parentCtor.prototype;this.superClass_=parentCtor.prototype;this.prototype=new tempCtor}
;Function.prototype.mixin=function(props){for(var x in props){this.prototype[x]=props[x]}if(typeof props["toString"]=="function"&&props["toString"]!=this.prototype["toString"]){this.prototype.toString=props.toString}}
;
function ListDictionary(name){this.name_=name;this.members_=[]}
ListDictionary.prototype.isMember=function(item){for(var i=0;i<this.members_.length;i++)if(this.members_[i]==item)return true;return false}
;ListDictionary.prototype.addMember=function(item){this.members_.push(item)}
;ListDictionary.prototype.removeMember=function(item){for(var i=0;i<this.members_.length;i++){if(this.members_[i]==item){for(var j=i;j<this.members_.length;j++)this.members_[j]=this.members_[j+1];this.members_.length--;return true}}return false}
;ListDictionary.prototype.forEach=function(func){if(typeof func!="function")throw new Error("argument to forEach is not a function, it's a(n) "+typeof func);for(var i=0;i<this.members_.length;i++)func(this.members_[i])}
;
function EventRegistrar(eventTypes){this.eventTypes=[];this.listeners_={};if(eventTypes instanceof Array){var events=eventTypes}else if(typeof eventTypes=="object"){var events=[];for(var e in eventTypes)events.push(eventTypes[e])}else{throw new Error("Unrecognized init parameter to EventRegistrar");}for(var i=0;i<events.length;i++){this.eventTypes.push(events[i]);this.listeners_[events[i]]=new ListDictionary(events[i]+"Listeners")}}
EventRegistrar.prototype.isKnownEventType=function(eventType){for(var i=0;i<this.eventTypes.length;i++)if(eventType==this.eventTypes[i])return eventType;return false}
;EventRegistrar.prototype.addEventType=function(eventType){if(this.isKnownEventType(eventType))throw new Error("Event type already known: "+eventType);this.eventTypes.push(eventType);this.listeners_[eventType]=new ListDictionary(eventType+"Listeners")}
;EventRegistrar.prototype.registerListener=function(eventType,listener){if(this.isKnownEventType(eventType)===false)throw new Error("Unknown event type: "+eventType);this.listeners_[eventType].addMember(listener)}
;EventRegistrar.prototype.removeListener=function(eventType,listener){if(this.isKnownEventType(eventType)===false)throw new Error("Unknown event type: "+eventType);this.listeners_[eventType].removeMember(listener)}
;EventRegistrar.prototype.fire=function(eventType,e){if(this.isKnownEventType(eventType)===false)throw new Error("Unknown event type: "+eventType);var invoke=function(listener){listener(e)}
;this.listeners_[eventType].forEach(invoke)}
;
function G_Preferences(opt_startPoint,opt_getDefaultBranch){this.debugZone="prefs";this.observers_={};var startPoint=opt_startPoint||null;var prefSvc=Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);if(opt_getDefaultBranch){this.prefs_=prefSvc.getDefaultBranch(startPoint)}else{this.prefs_=prefSvc.getBranch(startPoint)}this.prefs_.QueryInterface(Ci.nsIPrefBranchInternal)}
G_Preferences.setterMap_={string:"setCharPref","boolean":"setBoolPref",number:"setIntPref"};G_Preferences.getterMap_={};G_Preferences.getterMap_[Ci.nsIPrefBranch.PREF_STRING]="getCharPref";G_Preferences.getterMap_[Ci.nsIPrefBranch.PREF_BOOL]="getBoolPref";G_Preferences.getterMap_[Ci.nsIPrefBranch.PREF_INT]="getIntPref";G_Preferences.prototype.setPref=function(key,val){var datatype=typeof val;if(datatype=="number"&&val%1!=0){throw new Error("Cannot store non-integer numbers in preferences.");}var meth=
G_Preferences.setterMap_[datatype];if(!meth){throw new Error("Pref datatype {"+datatype+"} not supported.");}return this.prefs_[meth](key,val)}
;G_Preferences.prototype.getPref=function(key,opt_default){var type=this.prefs_.getPrefType(key);if(type==Ci.nsIPrefBranch.PREF_INVALID){return opt_default}var meth=G_Preferences.getterMap_[type];if(!meth){throw new Error("Pref datatype {"+type+"} not supported.");}try{return this.prefs_[meth](key)}catch(e){return opt_default}}
;G_Preferences.prototype.setBoolPref=function(which,value){return this.setPref(which,value)}
;G_Preferences.prototype.getBoolPref=function(which){return this.prefs_.getBoolPref(which)}
;G_Preferences.prototype.getBoolPrefOrDefault=function(which,def){return this.getPref(which,def)}
;G_Preferences.prototype.getBoolPrefOrDefaultAndSet=function(which,def){try{return this.prefs_.getBoolPref(which)}catch(e){this.prefs_.setBoolPref(which,!(!def));return def}}
;G_Preferences.prototype.clearPref=function(which){try{this.prefs_.clearUserPref(which)}catch(e){}}
;G_Preferences.prototype.addObserver=function(which,callback){var observer=new G_PreferenceObserver(callback);if(!this.observers_[which])this.observers_[which]=new G_ObjectSafeMap;this.observers_[which].insert(callback,observer);this.prefs_.addObserver(which,observer,false)}
;G_Preferences.prototype.removeObserver=function(which,callback){var observer=this.observers_[which].find(callback);this.prefs_.removeObserver(which,observer);this.observers_[which].erase(callback)}
;function G_PreferenceObserver(callback){this.debugZone="prefobserver";this.callback_=callback}
G_PreferenceObserver.prototype.observe=function(subject,topic,data){this.callback_(data)}
;G_PreferenceObserver.prototype.QueryInterface=function(iid){var Ci=Ci;if(iid.equals(Ci.nsISupports)||iid.equals(Ci.nsIObserves)||iid.equals(Ci.nsISupportsWeakReference))return this;throw Components.results.NS_ERROR_NO_INTERFACE;}
;
if(!isDef(false)){throw new Error("G_GDEBUG constant must be set before loading debug.js");}function G_Debug(who,msg){}
function G_DebugL(who,msg){}
function G_Assert(who,condition,msg){}
function G_DebugZone(service,prefix,zone){}
G_DebugZone.prototype.zoneIsEnabled=function(){}
;G_DebugZone.prototype.enableZone=function(){}
;G_DebugZone.prototype.disableZone=function(){}
;G_DebugZone.prototype.debug=function(msg){}
;G_DebugZone.prototype.error=function(msg){}
;G_DebugZone.prototype.assert=function(condition,msg){}
;function G_DebugService(opt_prefix){}
G_DebugService.ERROR_LEVEL_INFO="INFO";G_DebugService.ERROR_LEVEL_WARNING="WARNING";G_DebugService.ERROR_LEVEL_EXCEPTION="EXCEPTION";G_DebugService.TIMESTAMP_INTERVAL=300000;G_DebugService.prototype.QueryInterface=function(iid){if(iid.equals(Ci.nsISupports)||iid.equals(Ci.nsITimerCallback)){return this}throw Components.results.NS_ERROR_NO_INTERFACE;}
;G_DebugService.prototype.alsoDumpToShell=function(){}
;G_DebugService.prototype.alsoDumpToConsole=function(){}
;G_DebugService.prototype.logFileIsEnabled=function(){}
;G_DebugService.prototype.enableLogFile=function(){}
;G_DebugService.prototype.disableLogFile=function(){}
;G_DebugService.prototype.getLogFile=function(){}
;G_DebugService.prototype.setLogFile=function(file){}
;G_DebugService.prototype.closeLogFile=function(){this.logWriter_.close();this.logWriter_=null}
;G_DebugService.prototype.enableDumpToShell=function(){}
;G_DebugService.prototype.disableDumpToShell=function(){}
;G_DebugService.prototype.enableDumpToConsole=function(){}
;G_DebugService.prototype.disableDumpToConsole=function(){}
;G_DebugService.prototype.getZone=function(zone){}
;G_DebugService.prototype.enableZone=function(zone){}
;G_DebugService.prototype.disableZone=function(zone){}
;G_DebugService.prototype.allZonesEnabled=function(){}
;G_DebugService.prototype.enableAllZones=function(){}
;G_DebugService.prototype.disableAllZones=function(){}
;G_DebugService.prototype.callTracingEnabled=function(){}
;G_DebugService.prototype.enableCallTracing=function(){}
;G_DebugService.prototype.disableCallTracing=function(){}
;G_DebugService.prototype.getLogFileErrorLevel=function(){}
;G_DebugService.prototype.setLogFileErrorLevel=function(level){}
;G_DebugService.prototype.notify=function(timer){if(!this.activeSinceLastTimestamp_){return}this.dump(G_File.LINE_END_CHAR+"=========== Date: "+(new Date).toUTCString()+" ============"+G_File.LINE_END_CHAR+G_File.LINE_END_CHAR);this.activeSinceLastTimestamp_=false}
;G_DebugService.prototype.dump=function(msg){}
;G_DebugService.prototype.maybeDumpToFile=function(msg){if(this.logFileIsEnabled()&&this.logFile_){if(!this.logWriter_){this.logWriter_=new G_FileWriter(this.logFile_,true)}this.logWriter_.write(msg)}}
;G_DebugService.prototype.observe=function(consoleMessage){}
;G_DebugService.prototype.reportScriptError_=function(message,sourceName,lineNumber,label){if(sourceName.startsWith("http")){return}var message=["","------------------------------------------------------------",label+": "+message,"location: "+sourceName+", line: "+lineNumber,"------------------------------------------------------------","",""].join(G_File.LINE_END_CHAR);dump(message);this.maybeDumpToFile(message)}
;function G_Loggifier(){}
G_Loggifier.prototype.mark_=function(obj){}
;G_Loggifier.prototype.isLoggified=function(obj){}
;G_Loggifier.prototype.getFunctionName_=function(constructor){}
;G_Loggifier.prototype.loggify=function(obj){}
;function G_DebugSettings(){this.defaults_={};this.prefs_=new G_Preferences}
G_DebugSettings.prototype.getSetting=function(name,opt_default){var override=this.prefs_.getPref(name,null);if(override!==null){return override}else if(name in this.defaults_){return this.defaults_[name]}else{return opt_default}}
;G_DebugSettings.prototype.setDefault=function(name,val){this.defaults_[name]=val}
;var G_debugService=new G_DebugService;
var G_File={};G_File.getHomeFile=function(opt_file){return this.getSpecialFile("Home",opt_file)}
;G_File.getProfileFile=function(opt_file){return this.getSpecialFile("ProfD",opt_file)}
;G_File.getTempFile=function(opt_file){return this.getSpecialFile("TmpD",opt_file)}
;G_File.getSpecialFile=function(loc,opt_file){var file=Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get(loc,Ci.nsILocalFile);if(opt_file){file.append(opt_file)}return file}
;G_File.createUniqueTempFile=function(opt_baseName){var baseName=(opt_baseName||(new Date).getTime())+".tmp";var file=this.getSpecialFile("TmpD",baseName);file.createUnique(file.NORMAL_FILE_TYPE,420);return file}
;G_File.createUniqueTempDir=function(opt_baseName){var baseName=(opt_baseName||(new Date).getTime())+".tmp";var dir=this.getSpecialFile("TmpD",baseName);dir.createUnique(dir.DIRECTORY_TYPE,484);return dir}
;G_File.fromFileURI=function(uri){if(uri.indexOf("file://")!=0)throw new Error("File path must be a file:// URL");var fileHandler=Cc["@mozilla.org/network/protocol;1?name=file"].getService(Ci.nsIFileProtocolHandler);return fileHandler.getFileFromURLSpec(uri)}
;G_File.PR_RDONLY=1;G_File.PR_WRONLY=2;G_File.PR_RDWR=4;G_File.PR_CREATE_FILE=8;G_File.PR_APPEND=16;G_File.PR_TRUNCATE=32;G_File.PR_SYNC=64;G_File.PR_EXCL=128;G_File.__defineGetter__("LINE_END_CHAR",function(){var end_char;if("@mozilla.org/xre/app-info;1" in Cc){end_char=Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULRuntime).OS=="WINNT"?"\r\n":"\n"}else{end_char=Cc["@mozilla.org/network/protocol;1?name=http"].getService(Ci.nsIHttpProtocolHandler).platform.toLowerCase().indexOf("win")==0?"\r\n"
:"\n"}G_File.__defineGetter__("LINE_END_CHAR",function(){return end_char}
);return end_char}
);function G_FileReader(file){this.file_=isString(file)?G_File.fromFileURI(file):file}
G_FileReader.readAll=function(file){var reader=new G_FileReader(file);try{return reader.read()}finally{reader.close()}}
;G_FileReader.prototype.read=function(opt_maxBytes){if(!this.stream_){var fs=Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);fs.init(this.file_,G_File.PR_RDONLY,292,0);this.stream_=Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream);this.stream_.init(fs)}if(!isDef(opt_maxBytes)){opt_maxBytes=this.stream_.available()}return this.stream_.read(opt_maxBytes)}
;G_FileReader.prototype.close=function(opt_maxBytes){if(this.stream_){this.stream_.close();this.stream_=null}}
;function G_FileWriter(file,opt_append){this.file_=typeof file=="string"?G_File.fromFileURI(file):file;this.append_=!(!opt_append)}
G_FileWriter.writeAll=function(file,data,opt_append){var writer=new G_FileWriter(file,opt_append);try{return writer.write(data)}finally{writer.close();return 0}}
;G_FileWriter.prototype.write=function(data){if(!this.stream_){this.stream_=Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);var flags=G_File.PR_WRONLY|G_File.PR_CREATE_FILE|(this.append_?G_File.PR_APPEND:G_File.PR_TRUNCATE);this.stream_.init(this.file_,flags,-1,0)}return this.stream_.write(data,data.length)}
;G_FileWriter.prototype.writeLine=function(data){this.write(data+G_File.LINE_END_CHAR)}
;G_FileWriter.prototype.close=function(){if(this.stream_){this.stream_.close();this.stream_=null}}
;
function G_ObjectSafeMap(opt_name){this.debugZone="objectsafemap";this.name_=opt_name?opt_name:"noname";this.keys_=[];this.values_=[]}
G_ObjectSafeMap.prototype.indexOfKey_=function(key){for(var i=0;i<this.keys_.length;i++)if(this.keys_[i]===key)return i;return-1}
;G_ObjectSafeMap.prototype.insert=function(key,value){if(key===null)throw new Error("Can't use null as a key");if(value===undefined)throw new Error("Can't store undefined values in this map");var i=this.indexOfKey_(key);if(i==-1){this.keys_.push(key);this.values_.push(value)}else{this.keys_[i]=key;this.values_[i]=value}}
;G_ObjectSafeMap.prototype.erase=function(key){var keyLocation=this.indexOfKey_(key);var keyFound=keyLocation!=-1;if(keyFound){this.keys_.splice(keyLocation,1);this.values_.splice(keyLocation,1)}return keyFound}
;G_ObjectSafeMap.prototype.find=function(key){var keyLocation=this.indexOfKey_(key);return keyLocation==-1?undefined:this.values_[keyLocation]}
;G_ObjectSafeMap.prototype.replace=function(other){this.keys_=[];this.values_=[];for(var i=0;i<other.keys_.length;i++){this.keys_.push(other.keys_[i]);this.values_.push(other.values_[i])}}
;G_ObjectSafeMap.prototype.forEach=function(func){if(typeof func!="function")throw new Error("argument to forEach is not a function, it's a(n) "+typeof func);for(var i=0;i<this.keys_.length;i++)func(this.keys_[i],this.values_[i])}
;G_ObjectSafeMap.prototype.size=function(){return this.keys_.length}
;
function G_Alarm(callback,delayMS,opt_repeating,opt_maxTimes){this.debugZone="alarm";this.callback_=callback;this.repeating_=!(!opt_repeating);var Cc=Components.classes;var Ci=Components.interfaces;this.timer_=Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);var type=opt_repeating?this.timer_.TYPE_REPEATING_SLACK:this.timer_.TYPE_ONE_SHOT;this.maxTimes_=opt_maxTimes?opt_maxTimes:null;this.nTimes_=0;this.timer_.initWithCallback(this,delayMS,type)}
G_Alarm.prototype.cancel=function(){if(this.timer_){this.timer_.cancel();this.timer_=null;this.callback_=null}}
;G_Alarm.prototype.notify=function(timer){var ret=this.callback_();this.nTimes_++;if(this.repeating_&&typeof this.maxTimes_=="number"&&this.nTimes_>=this.maxTimes_){this.cancel()}else if(!this.repeating_){this.cancel()}return ret}
;G_Alarm.prototype.QueryInterface=function(iid){if(iid.equals(Components.interfaces.nsISupports)||iid.equals(Components.interfaces.nsIObserver)||iid.equals(Components.interfaces.nsITimerCallback))return this;throw Components.results.NS_ERROR_NO_INTERFACE;}
;function G_ConditionalAlarm(callback,delayMS,opt_repeating,opt_maxTimes){G_Alarm.call(this,callback,delayMS,opt_repeating,opt_maxTimes);this.debugZone="conditionalalarm"}
G_ConditionalAlarm.inherits(G_Alarm);G_ConditionalAlarm.prototype.notify=function(timer){var rv=G_Alarm.prototype.notify.call(this,timer);if(this.repeating_&&rv){this.cancel()}}
;
function G_JSModule(){this.factoryLookup_={};this.categoriesLookup_={}}
G_JSModule.prototype.registerObject=function(classID,contractID,className,instance,opt_categories){this.factoryLookup_[classID]=new G_JSFactory(Components.ID(classID),contractID,className,instance,opt_categories);this.categoriesLookup_[classID]=opt_categories}
;G_JSModule.prototype.registerSelf=function(compMgr,fileSpec,location,type){compMgr=compMgr.QueryInterface(Ci.nsIComponentRegistrar);for(var factory in this.factoryLookup_){compMgr.registerFactoryLocation(this.factoryLookup_[factory].classID,this.factoryLookup_[factory].className,this.factoryLookup_[factory].contractID,fileSpec,location,type);this.factoryLookup_[factory].registerCategories()}}
;G_JSModule.prototype.getClassObject=function(compMgr,classID,interfaceID){var factory=this.factoryLookup_[classID.toString()];if(!factory){throw new Error("Invalid classID {%s}".subs(classID));}return factory}
;G_JSModule.prototype.canUnload=function(){return true}
;function G_JSFactory(classID,contractID,className,instance,opt_categories){this.classID=classID;this.contractID=contractID;this.className=className;this.instance_=instance;this.categories_=opt_categories}
G_JSFactory.prototype.registerCategories=function(){if(this.categories_){var catMgr=Cc["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager);for(var i=0,cat;cat=this.categories_[i];i++){catMgr.addCategoryEntry(cat,this.className,this.contractID,true,true)}}}
;G_JSFactory.prototype.createInstance=function(outer,iid){return this.instance_}
;
function BindToObject(func,obj,opt_A,opt_B,opt_C,opt_D,opt_E,opt_F){var args=Array.prototype.splice.call(arguments,1,arguments.length);return Function.prototype.bind.apply(func,args)}
;
function G_TabbedBrowserWatcher(tabBrowser,name,opt_filterAboutBlank){this.debugZone="tabbedbrowserwatcher";this.tabBrowser_=tabBrowser;this.filterAboutBlank_=!(!opt_filterAboutBlank);this.events=G_TabbedBrowserWatcher.events;this.name_=name;this.mark_=G_TabbedBrowserWatcher.mark_+"-"+this.name_;this.registrar_=new EventRegistrar(G_TabbedBrowserWatcher.events);this.tabbox_=this.getTabBrowser().mTabBox;this.onDOMContentLoadedClosure_=BindToObject(this.onDOMContentLoaded,this);this.tabbox_.addEventListener(
"DOMContentLoaded",this.onDOMContentLoadedClosure_,true);this.onDOMNodeInsertedClosure_=BindToObject(this.onDOMNodeInserted,this);this.tabbox_.addEventListener("DOMNodeInserted",this.onDOMNodeInsertedClosure_,true);this.onTabSwitchClosure_=BindToObject(this.onTabSwitch,this);this.tabbox_.addEventListener("select",this.onTabSwitchClosure_,true);var win=this.tabbox_.ownerDocument.defaultView;this.onChromeUnloadClosure_=BindToObject(this.onChromeUnload_,this);win.addEventListener("unload",this.onChromeUnloadClosure_,
false);this.lastTab_=this.getCurrentBrowser();this.detectNewTabs_()}
G_TabbedBrowserWatcher.events={DOMCONTENTLOADED:"domcontentloaded",LOCATIONCHANGE:"locationchange",PAGESHOW:"pageshow",PAGEHIDE:"pagehide",LOAD:"load",UNLOAD:"unload",TABLOAD:"tabload",TABUNLOAD:"tabunload",TABSWITCH:"tabswitch",TABMOVE:"tabmove"};G_TabbedBrowserWatcher.mark_="watcher-marked";G_TabbedBrowserWatcher.prototype.onChromeUnload_=function(event){if(this.tabbox_){this.tabbox_.removeEventListener("DOMContentLoaded",this.onDOMContentLoadedClosure_,true);this.tabbox_.removeEventListener("DOMNodeInserted"
,this.onDOMNodeInsertedClosure_,true);this.tabbox_.removeEventListener("select",this.onTabSwitchClosure_,true);var win=this.tabbox_.ownerDocument.defaultView;win.removeEventListener("unload",this.onChromeUnloadClosure_,false);this.tabbox_=null}if(this.lastTab_){this.lastTab_=null}if(this.tabBrowser_){this.tabBrowser_=null}}
;G_TabbedBrowserWatcher.prototype.isInstrumented_=function(browser){return!(!browser[this.mark_])}
;G_TabbedBrowserWatcher.prototype.instrumentBrowser_=function(browser){G_Assert(this,!this.isInstrumented_(browser),"Browser already instrumented!");new G_BrowserWatcher(this,browser);browser[this.mark_]=true}
;G_TabbedBrowserWatcher.prototype.detectNewTabs_=function(){var tb=this.getTabBrowser();for(var i=0;i<tb.browsers.length;++i)this.maybeFireTabLoad(tb.browsers[i])}
;G_TabbedBrowserWatcher.prototype.registerListener=function(eventType,listener){this.registrar_.registerListener(eventType,listener)}
;G_TabbedBrowserWatcher.prototype.removeListener=function(eventType,listener){this.registrar_.removeListener(eventType,listener)}
;G_TabbedBrowserWatcher.prototype.fire=function(eventType,e){this.registrar_.fire(eventType,e)}
;G_TabbedBrowserWatcher.prototype.fireDocEvent_=function(eventType,doc,browser){if(!this.tabBrowser_){return}try{var isTop=doc==browser.contentDocument}catch(e){var isTop=undefined}var inSelected=browser==this.getCurrentBrowser();var location=doc?doc.location.href:undefined;if(!this.filterAboutBlank_||location!="about:blank"){this.fire(eventType,{doc:doc,isTop:isTop,inSelected:inSelected,browser:browser})}}
;G_TabbedBrowserWatcher.prototype.maybeFireTabLoad=function(browser){if(!this.isInstrumented_(browser)){this.instrumentBrowser_(browser);this.fire(this.events.TABLOAD,{browser:browser})}}
;G_TabbedBrowserWatcher.prototype.onDOMContentLoaded=function(e){var doc=e.target;var browser=this.getBrowserFromDocument(doc);if(!browser){return}this.maybeFireTabLoad(browser);this.fireDocEvent_(this.events.DOMCONTENTLOADED,doc,browser)}
;G_TabbedBrowserWatcher.prototype.onDOMNodeInserted=function(e){if(e.target.localName!="tab"){return}if(!isDef(e.target._tPos)){return}var fromPos=e.target._tPos;var toPos;for(var i=0;i<e.relatedNode.childNodes.length;i++){var child=e.relatedNode.childNodes[i];if(child==e.target){toPos=i;break}}this.fire(this.events.TABMOVE,{tab:e.target,fromIndex:fromPos,toIndex:toPos})}
;G_TabbedBrowserWatcher.prototype.onTabSwitch=function(e){if(e.target==null||e.target.localName!="tabs"&&e.target.localName!="tabpanels")return;var fromBrowser=this.lastTab_;var toBrowser=this.getCurrentBrowser();if(fromBrowser!=toBrowser){this.lastTab_=toBrowser;this.fire(this.events.TABSWITCH,{fromBrowser:fromBrowser,toBrowser:toBrowser})}}
;G_TabbedBrowserWatcher.prototype.getTabBrowser=function(){return this.tabBrowser_}
;G_TabbedBrowserWatcher.prototype.getCurrentBrowser=function(){return this.getTabBrowser().selectedBrowser}
;G_TabbedBrowserWatcher.prototype.getCurrentWindow=function(){return this.getCurrentBrowser().contentWindow}
;G_TabbedBrowserWatcher.prototype.getBrowserFromDocument=function(doc){function docInWindow(doc,win){if(win.document==doc)return true;if(win.frames)for(var i=0;i<win.frames.length;i++)if(docInWindow(doc,win.frames[i]))return true;return false}
var browsers=this.getTabBrowser().browsers;for(var i=0;i<browsers.length;i++)if(docInWindow(doc,browsers[i].contentWindow))return browsers[i];return null}
;G_TabbedBrowserWatcher.prototype.getDocumentFromURL=function(url,opt_browser){function docWithURL(win,url){if(win.document.location.href==url)return win.document;if(win.frames)for(var i=0;i<win.frames.length;i++){var rv=docWithURL(win.frames[i],url);if(rv)return rv}return null}
if(opt_browser)return docWithURL(opt_browser.contentWindow,url);var browsers=this.getTabBrowser().browsers;for(var i=0;i<browsers.length;i++){var rv=docWithURL(browsers[i].contentWindow,url);if(rv)return rv}return null}
;G_TabbedBrowserWatcher.prototype.getDocumentsFromURL=function(url,opt_browser){var docs=[];function getDocsWithURL(win,url){if(win.document.location.href==url)docs.push(win.document);if(win.frames)for(var i=0;i<win.frames.length;i++)getDocsWithURL(win.frames[i],url)}
if(opt_browser)return getDocsWithURL(opt_browser.contentWindow,url);var browsers=this.getTabBrowser().browsers;for(var i=0;i<browsers.length;i++)getDocsWithURL(browsers[i].contentWindow,url);return docs}
;G_TabbedBrowserWatcher.prototype.getBrowserFromWindow=function(sub){function containsSubWindow(sub,win){if(win==sub)return true;if(win.frames)for(var i=0;i<win.frames.length;i++)if(containsSubWindow(sub,win.frames[i]))return true;return false}
var browsers=this.getTabBrowser().browsers;for(var i=0;i<browsers.length;i++)if(containsSubWindow(sub,browsers[i].contentWindow))return browsers[i];return null}
;G_TabbedBrowserWatcher.getTabElementFromBrowser=function(tabBrowser,browser){for(var i=0;i<tabBrowser.browsers.length;i++)if(tabBrowser.browsers[i]==browser)return tabBrowser.mTabContainer.childNodes[i];return null}
;function G_BrowserWatcher(tabbedBrowserWatcher,browser){this.debugZone="browserwatcher";this.parent_=tabbedBrowserWatcher;this.browser_=browser;this.onPageShowClosure_=BindToObject(this.onPageShow,this);this.browser_.addEventListener("pageshow",this.onPageShowClosure_,true);this.onPageHideClosure_=BindToObject(this.onPageHide,this);this.browser_.addEventListener("pagehide",this.onPageHideClosure_,true);this.onLoadClosure_=BindToObject(this.onLoad,this);this.browser_.addEventListener("load",this.onLoadClosure_,
true);this.onUnloadClosure_=BindToObject(this.onUnload,this);this.browser_.addEventListener("unload",this.onUnloadClosure_,true);this.webProgressListener_={QueryInterface:function(){return this}
,onLocationChange:bind(this.onLocationChange,this),onStateChange:function(){}
,onStatusChange:function(){}
,onSecurityChange:function(){}
,onProgressChange:function(){}
};this.browser_.addProgressListener(this.webProgressListener_,Ci.nsIWebProgress.NOTIFY_LOCATION)}
G_BrowserWatcher.prototype.onLocationChange=function(webProgress,request,location){G_Debug(this,"onLocationChange for {%s}".subs(location.spec));if(!this.parent_){return}var e={browser:this.browser_,isTop:true};this.parent_.fire(this.parent_.events.LOCATIONCHANGE,e)}
;G_BrowserWatcher.prototype.onPageShow=function(e){if(e.target&&e.target.nodeName=="#document"){var doc=e.target;this.parent_.fireDocEvent_(this.parent_.events.PAGESHOW,doc,this.browser_)}}
;G_BrowserWatcher.prototype.onLoad=function(e){if(!e.target){return}if(e.target.nodeName!="#document")return;var doc=e.target;this.parent_.fireDocEvent_(this.parent_.events.LOAD,doc,this.browser_)}
;G_BrowserWatcher.prototype.onUnload=function(e){var doc=e.target;if(doc&&doc.nodeName=="#document")this.parent_.fireDocEvent_("unload",doc,this.browser_);if(!doc){this.parent_.fire(this.parent_.events.TABUNLOAD,{browser:this.browser_});this.browser_.removeEventListener("pageshow",this.onPageShowClosure_,true);this.browser_.removeEventListener("pagehide",this.onPageHideClosure_,true);this.browser_.removeEventListener("load",this.onLoadClosure_,true);this.browser_.removeEventListener("unload",this.onUnloadClosure_,
true);this.parent_=null;this.browser_=null}}
;G_BrowserWatcher.prototype.onPageHide=function(e){if(e.target.nodeName!="#document")return;var doc=e.target;this.parent_.fireDocEvent_(this.parent_.events.PAGEHIDE,doc,this.browser_)}
;
function G_Base64(){this.byteToCharMap_={};this.charToByteMap_={};this.byteToCharMapWebSafe_={};this.charToByteMapWebSafe_={};this.init_()}
G_Base64.ENCODED_VALS="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";G_Base64.ENCODED_VALS_WEBSAFE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=";G_Base64.prototype.init_=function(){for(var i=0;i<G_Base64.ENCODED_VALS.length;i++){this.byteToCharMap_[i]=G_Base64.ENCODED_VALS.charAt(i);this.charToByteMap_[this.byteToCharMap_[i]]=i;this.byteToCharMapWebSafe_[i]=G_Base64.ENCODED_VALS_WEBSAFE.charAt(i);this.charToByteMapWebSafe_[this.byteToCharMapWebSafe_[i]]=
i}}
;G_Base64.prototype.encodeByteArray=function(input,opt_webSafe){if(!(input instanceof Array))throw new Error("encodeByteArray takes an array as a parameter");var byteToCharMap=opt_webSafe?this.byteToCharMapWebSafe_:this.byteToCharMap_;var output=[];var i=0;while(i<input.length){var byte1=input[i];var haveByte2=i+1<input.length;var byte2=haveByte2?input[i+1]:0;var haveByte3=i+2<input.length;var byte3=haveByte3?input[i+2]:0;var outByte1=byte1>>2;var outByte2=(byte1&3)<<4|byte2>>4;var outByte3=(byte2&
15)<<2|byte3>>6;var outByte4=byte3&63;if(!haveByte3){outByte4=64;if(!haveByte2)outByte3=64}output.push(byteToCharMap[outByte1]);output.push(byteToCharMap[outByte2]);output.push(byteToCharMap[outByte3]);output.push(byteToCharMap[outByte4]);i+=3}return output.join("")}
;G_Base64.prototype.decodeString=function(input,opt_webSafe){if(input.length%4)throw new Error("Length of b64-encoded data must be zero mod four");var charToByteMap=opt_webSafe?this.charToByteMapWebSafe_:this.charToByteMap_;var output=[];var i=0;while(i<input.length){var byte1=charToByteMap[input.charAt(i)];var byte2=charToByteMap[input.charAt(i+1)];var byte3=charToByteMap[input.charAt(i+2)];var byte4=charToByteMap[input.charAt(i+3)];if(byte1===undefined||byte2===undefined||byte3===undefined||byte4===
undefined)throw new Error("String contains characters not in our alphabet: "+input);var outByte1=byte1<<2|byte2>>4;output.push(outByte1);if(byte3!=64){var outByte2=byte2<<4&240|byte3>>2;output.push(outByte2);if(byte4!=64){var outByte3=byte3<<6&192|byte4;output.push(outByte3)}}i+=4}return output}
;G_Base64.prototype.arrayifyString=function(str){var output=[];for(var i=0;i<str.length;i++){var c=str.charCodeAt(i);while(c>255){output.push(c&255);c>>=8}output.push(c)}return output}
;G_Base64.prototype.stringifyArray=function(array){var output=[];for(var i=0;i<array.length;i++)output[i]=String.fromCharCode(array[i]);return output.join("")}
;
function G_Requester(timeoutMillis){this.status="";this.responseText="";this.timeout_=timeoutMillis?timeoutMillis:10000;this.timeoutExpired_=false}
G_Requester.prototype.Open=function(url,options){G_Debug(this,"Sending Async Req To: %s".subs(url));var channel=Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newChannel(url,null,null);channel.QueryInterface(Ci.nsIHttpChannel);if(options.postData){var newData=new Array;for(var i=0;i<options.postData.length;i++){if(options.postData.charCodeAt(i)>128){G_Debug(this,"Fixing %s".subs(options.postData.charCodeAt(i)));newData.push("&#"+options.postData.charCodeAt(i)+";")}else{newData.push(
options.postData.charAt(i))}}newData=newData.join("");var uploadCh=channel.QueryInterface(Ci.nsIUploadChannel);var sis=Cc["@mozilla.org/io/string-input-stream;1"].createInstance(Ci.nsIStringInputStream);sis.setData(newData,-1);uploadCh.setUploadStream(sis,"application/xml",-1);channel.requestMethod="POST"}if(isDef(options.username)||isDef(options.password)){var encoder=new G_Base64;var as=encoder.arrayifyString(options.username+":"+options.password);var enc=encoder.encodeByteArray(as);channel.setRequestHeader(
"Authorization","BASIC "+enc,false)}channel.setRequestHeader("Content-Type","application/xml",false);channel.setRequestHeader("Accept-Encoding","compress, gzip",false);channel.setRequestHeader("Connection","close",false);if(options.headers){for(var headerName in options.headers){channel.setRequestHeader(headerName,options.headers[headerName],false)}}channel.asyncOpen(this,null);this.timer_=new G_Alarm(this.Timeout.bind(this),this.timeout_)}
;G_Requester.prototype.Timeout=function(){this.timeoutExpired_=true;this.OnFailure()}
;G_Requester.prototype.onStartRequest=function(request,context){if(this.timeoutExpired_){return false}this.status=request.QueryInterface(Ci.nsIHttpChannel).responseStatus}
;G_Requester.prototype.onDataAvailable=function(request,context,inputStream,offset,count){if(this.timeoutExpired_){return false}var sis=Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream);sis.init(inputStream);var text=sis.read(count);this.responseText+=text;G_Debug(this,"Streaming: %s".subs(text))}
;G_Requester.prototype.onStopRequest=function(request,context,status){if(this.timeoutExpired_){return false}this.timer_.cancel();this.OnSuccess()}
;G_Requester.prototype.OnSuccess=function(){}
;G_Requester.prototype.OnFailure=function(){}
;G_Requester.prototype.debugZone="G_Requester";
function G_ExtensionUpdater(id,requestOptions){if(!id){return false}this.RDFSvc_=Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService);if(requestOptions){this.requestOptions_=requestOptions}else{this.requestOptions_={}}this.id=id;this.updating=false;this.preferences=new G_Preferences("extensions.google.updater.")}
G_ExtensionUpdater.prototype.Update=function(){if(this.updating){return false}this.updating=true;this.appVersion="";this.appID="";this.currentVersion="";this.updateURL="";this.updateLink="";this.updateVersion="";if(!this.GetCurrent()){this.Failure("'%s' not found in extension manager.".subs(this.name));return false}this.AttemptUpdate()}
;G_ExtensionUpdater.prototype.UpdatePeriodically=function(opt_makeTimer){var lastUpdate=this.preferences.getPref(this.id,0);var timeBetweenUpdates=86400000;var nextUpdate=Number(lastUpdate)+timeBetweenUpdates;var now=(new Date).getTime();if(now>nextUpdate){this.preferences.setPref(this.id,String(now));this.Update();nextUpdate=now+timeBetweenUpdates}if(opt_makeTimer){this.loop_=new G_Alarm(this.UpdatePeriodically.bind(this,true),nextUpdate-now,false)}}
;G_ExtensionUpdater.prototype.CompareVersions=function(aV1,aV2){var v1=aV1.split(".");var v2=aV2.split(".");var numSubversions=v1.length>v2.length?v1.length:v2.length;for(var i=0;i<numSubversions;i++){if(typeof v2[i]=="undefined"){return 1}if(typeof v1[i]=="undefined"){return-1}if(parseInt(v2[i])>parseInt(v1[i])){return-1}else if(parseInt(v2[i])<parseInt(v1[i])){return 1}}return 0}
;G_ExtensionUpdater.prototype.GetCurrent=function(){var updItem=Cc["@mozilla.org/extensions/manager;1"].getService(Ci.nsIExtensionManager).getItemForID(this.id);if(updItem){var appInfo=Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULAppInfo);this.name=updItem.name;this.currentVersion=updItem.version;this.updateURL=updItem.updateRDF;this.updateURL=this.updateURL.replace(/%ITEM_VERSION%/gi,this.currentVersion).replace(/%ITEM_ID%/gi,this.id).replace(/%APP_VERSION%/gi,appInfo.version).replace(/%APP_ID%/gi,
appInfo.ID);return true}return false}
;G_ExtensionUpdater.prototype.AttemptUpdate=function(){if(!this.updateURL){return false}this.req_=new G_Requester;this.req_.OnSuccess=this.OnReqSuccess.bind(this);this.req_.OnFailure=this.OnReqFailure.bind(this);this.req_.Open(this.updateURL,this.requestOptions_)}
;G_ExtensionUpdater.prototype.OnReqFailure=function(){this.OnFail()}
;G_ExtensionUpdater.prototype.OnReqSuccess=function(){if(this.req_.status!=200||!this.req_.responseText.match(/<rdf/gi)){G_Debug(this,"Error: Invalid Update RDF contents. HTTP Status '%s'".subs(this.req_.status));this.OnFail();return false}var uri=Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI(this.updateURL,null,null);var parser=Cc["@mozilla.org/rdf/xml-parser;1"].createInstance(Ci.nsIRDFXMLParser);var memoryDS=Cc["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"
].createInstance(Ci.nsIRDFDataSource);parser.parseString(memoryDS,uri,this.req_.responseText);var moz="http://www.mozilla.org/2004/em-rdf#";var versionArc=this.RDFSvc_.GetResource(moz+"version");var updateLinkArc=this.RDFSvc_.GetResource(moz+"updateLink");var thisResource=null;var dsResources=memoryDS.GetAllResources();while(dsResources.hasMoreElements()){thisResource=dsResources.getNext().QueryInterface(Ci.nsIRDFResource);var versionRes=memoryDS.GetTarget(thisResource,versionArc,true);if(versionRes)
{this.updateVersion=versionRes.QueryInterface(Ci.nsIRDFLiteral).Value}var updateLinkRes=memoryDS.GetTarget(thisResource,updateLinkArc,true);if(updateLinkRes){this.updateLink=updateLinkRes.QueryInterface(Ci.nsIRDFLiteral).Value}}if(this.updateVersion&&this.updateLink){G_Debug(this,"currentVersion:%s\nupdateVersion: %s\nupdateLink: %s".subs(this.currentVersion,this.updateVersion,this.updateLink));if(this.CompareVersions(this.updateVersion,this.currentVersion)==1){this.InstallUpdate()}}}
;G_ExtensionUpdater.prototype.InstallUpdate=function(){if(!this.updateLink){this.Failure("Failure");return false}var manager=Cc["@mozilla.org/xpinstall/install-manager;1"].createInstance(Ci.nsIXPInstallManager);if(manager!=null){G_Debug(this,"UpdateLink: %s".subs(this.updateLink));this.OnUpdateAvailable();var items=[this.updateLink];var p=new G_Preferences;var autoupdate=p.getPref("extensions.google.%s.autoupdate".subs(this.id.split("@")[0]),true);if(autoupdate==false){G_DebugL(this,"Extension '%s' would've been updated"
.subs(this.name));this.Success()}else{G_DebugL(this,"Extension '%s' updating...".subs(this.name));manager.initManagerFromChrome(items,items.length,this)}}else{this.Failure()}}
;G_ExtensionUpdater.prototype.onStateChange=function(index,state,value){if(state==Ci.nsIXPIProgressDialog.INSTALL_DONE){if(value!=0){this.Failure()}else{this.Success()}}}
;G_ExtensionUpdater.prototype.onProgress=function(index,value,maxValue){}
;G_ExtensionUpdater.prototype.Failure=function(aMessage){G_Debug(this,"Failure: %s".subs(aMessage));this.updating=false;this.OnFail(aMessage)}
;G_ExtensionUpdater.prototype.Success=function(){this.updating=false;this.OnSuccess()}
;G_ExtensionUpdater.prototype.OnFail=function(aMessage){}
;G_ExtensionUpdater.prototype.OnSuccess=function(){}
;G_ExtensionUpdater.prototype.OnUpdateAvailable=function(){}
;G_ExtensionUpdater.prototype.debugZone="G_ExtensionUpdater";
function GNOTES_AddButton(overlay,fullpageUrl){this.overlay_=overlay;this.showButton_=false;this.fullpageUrl=fullpageUrl}
GNOTES_AddButton.prototype.DIV_ID="gn_notemagic";GNOTES_AddButton.prototype.IsBlacklisted_=function(url){if(url.indexOf(this.fullpageUrl_)==0||url=="http://www.google.com/notebook"){return true}return false}
;GNOTES_AddButton.prototype.OnAddClick_=function(div,win,button){var bod=button.cachedContents.replace(/^\s+|\s+$/g,"");var doc=div.ownerDocument;var t=doc.title+"";var u=win.location.href+"";if(t==null||t==""){t=u;t=t.substring(t.indexOf("//")+2)}div.parentNode.removeChild(div);var sel=win.getSelection();sel.collapseToEnd();this.overlay_.AddEntry(bod,t,u);return false}
;GNOTES_AddButton.prototype.GetX_=function(elt){if(elt!=null&&elt.tagName!="BODY"){return elt.offsetLeft+this.GetX_(elt.offsetParent)}return 0}
;GNOTES_AddButton.prototype.GetY_=function(elt){if(elt!=null&&elt.tagName!="BODY"){return elt.offsetTop+this.GetY_(elt.offsetParent)}return 0}
;GNOTES_AddButton.prototype.SizeIframe_=function(button,div){div.style.width=button.clientWidth+4+"px";div.style.height=button.clientHeight+4+"px"}
;GNOTES_AddButton.prototype.SetShowButton=function(newVal){this.showButton_=newVal}
;GNOTES_AddButton.prototype.OnButtonMouseOver_=function(button,div){button.value="Note this +";div.style.MozOpacity=1;this.SizeIframe_(button,div)}
;GNOTES_AddButton.prototype.OnButtonMouseOut_=function(button,div){button.value="+";div.style.MozOpacity=0.7;this.SizeIframe_(button,div)}
;GNOTES_AddButton.prototype.MakeButton_=function(doc,selr,div,win){var button=doc.createElement("input");button.setAttribute("type","button");button.id="gnotesaddbutton";var buttonStyle=button.style;buttonStyle.fontSize="83%";buttonStyle.fontFamily="sans-serif";buttonStyle.padding="0px 0px 0px 0px";buttonStyle.backgroundColor="#BADCFF";var self=this;button.value="+";div.addEventListener("mouseover",function(event){self.OnButtonMouseOver_(button,div)}
,false);div.addEventListener("mouseout",function(event){self.OnButtonMouseOut_(button,div)}
,false);button.addEventListener("mousedown",function(event){self.OnAddClick_(div,win,button)}
,true);button.cachedContents=this.overlay_.SerializeRange(doc,selr);return button}
;GNOTES_AddButton.prototype.OnMouseClick=function(event){var doc=event.originalTarget.ownerDocument;var b=doc.getElementById(this.DIV_ID);if(b!=null){b.parentNode.removeChild(b)}}
;GNOTES_AddButton.prototype.OnMouseDown=function(event){this.downX_=event.pageX;this.downY_=event.pageY;return true}
;GNOTES_AddButton.prototype.OnMouseUp=function(event){var browser=this.overlay_.GetCurrentBrowser();var win=event.view;var doc=event.originalTarget.ownerDocument;if(this.IsBlacklisted_(win.location.href)){return true}if(doc.contentType!="text/html"){return true}var b=doc.getElementById(this.DIV_ID);if(b!=null){b.parentNode.removeChild(b)}var selr=this.overlay_.GetValidSelectionRange(win);if(selr==null){this.overlay_.NotifySelection(false);return true}this.overlay_.NotifySelection(true);if(!this.showButton_)
{return true}var div=doc.createElement("iframe");div.id=this.DIV_ID;div.setAttribute("frameborder","0");var divStyle=div.style;divStyle.position="absolute";divStyle.display="block";divStyle.MozOpacity="0.7";divStyle.zIndex=500;divStyle.width="1px";divStyle.height="1px";var self=this;div.addEventListener("load",function(){var iDoc=div.contentDocument;var iBody=iDoc.body;while(iBody.firstChild){iBody.removeChild(iBody.firstChild)}var button=self.MakeButton_(iDoc,selr,div,win);iBody.style.margin="0"
;iBody.style.padding="0";iBody.appendChild(button);self.SizeIframe_(button,div)}
,false);div.setAttribute("src","http://www.google.com/gn/static_files/blank.html");doc.body.appendChild(div);var endNode=selr.endContainer;var isText=endNode.nodeType==3;if(isText){endNode.splitText(selr.endOffset)}var x=doc.createElement("a");if(endNode.nextSibling){endNode.parentNode.insertBefore(x,endNode.nextSibling)}else{endNode.parentNode.appendChild(x)}var desiredY=this.GetY_(x)+4;var desiredX=doc.body.clientWidth-this.GetX_(x);if(desiredX>doc.body.clientWidth-200){desiredX=doc.body.clientWidth-
200}if(desiredX<100){desiredX=100}divStyle.top=desiredY+"px";divStyle.right=desiredX+"px";return true}
;
function GNOTES_ResultsPage(overlay){this.overlay_=overlay}
GNOTES_ResultsPage.prototype.IsSearchUrl_=function(url){if(url.indexOf("http://www.google.com/search")==0||url.indexOf("http://images.google.com/images")==0){return true}return false}
;GNOTES_ResultsPage.prototype.AddCallback_=function(content,title,url,searchurl,obj){this.overlay_.AddEntry(content,title,url,searchurl)}
;GNOTES_ResultsPage.prototype.AnnotateSearch=function(event){var doc=event.browser.contentDocument;var win=event.browser.contentWindow;var loc=win.location.href;if(!this.IsSearchUrl_(loc))return;if(isDef(win.gnb)){if(isDef(win.gnb._added)){return}win.gnb._added=true;win.gnb._show=function(){}
;win.gnb._doAdd=this.AddCallback_.bind(this);if(isDef(win.gnb._hidden)){var spans=doc.getElementsByTagName("SPAN");for(var i=0;i<spans.length;++i){var span=spans[i];if(span.className="bl"){span.style.display="inline"}}}}}
;
function GNOTES_Observer(){}
GNOTES_Observer.prototype.observe=function(subject,topic,data){if(topic=="app-startup"){this.obsSvc_=Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);this.obsSvc_.addObserver(this,"profile-after-change",false)}else if(topic=="profile-after-change"){var updater=new G_ExtensionUpdater("notebook@google.com");updater.UpdatePeriodically(true)}}
;
function GNOTES_BrowserOverlay(win){this.win_=win;this.doc_=this.win_.document;this.win_.addEventListener("load",this.Init_.bind(this),false);this.win_.addEventListener("resize",this.PositionBox_.bind(this),false);this.clientParam_="client=gnotesff&v="+this.VERSION;this.debugZone="gnotes";this.state_=null}
GNOTES_BrowserOverlay.prototype.WHITESPACE_REGEXP=/^(\s*)$/;GNOTES_BrowserOverlay.prototype.VERSION="1.0.0.5";GNOTES_BrowserOverlay.prototype.SERVER="http://www.google.com/notebook/";GNOTES_BrowserOverlay.prototype.GetCurrentBrowser=function(){return this.watcher_.getCurrentBrowser()}
;GNOTES_BrowserOverlay.prototype.GetOverlayElt_=function(){return this.overlayElt_}
;GNOTES_BrowserOverlay.prototype.SetStatusBarText_=function(msg){this.statusElt_.label=msg}
;GNOTES_BrowserOverlay.prototype.GetIframeElt_=function(){return this.doc_.getElementById("gnotes-ifr")}
;GNOTES_BrowserOverlay.prototype.GetInterfaceObj_=function(ifr){if(isNull(ifr)||isNull(ifr.contentWindow)||!isDef(ifr.contentWindow._GN_interface)){return null}return ifr.contentWindow._GN_interface}
;GNOTES_BrowserOverlay.prototype.MakeImageTag_=function(img){var dims="";if(img.height>150||img.width>150){var dims=img.height>img.width?"height='150'":"width='150'"}return"<img src="+img.src+" "+dims+">"}
;GNOTES_BrowserOverlay.prototype.IframeLoadCallback_=function(){var ifr=this.GetIframeElt_();if(ifr==null)return;var win=ifr.contentWindow;var gnInterface=this.GetInterfaceObj_(ifr);if(gnInterface==null){this.HideBox_();if(isDef(win.location)&&isDef(win.location.href)&&win.location.href.indexOf(this.onpageUrl_)==0){this.NavigateUrl_(win.location.href+"")}else{this.SetStatusBarText_("Cannot reach server")}return true}var overlay=this.GetOverlayElt_();this.SetStatusBarText_("Close Notebook");if(this.state_!=
null){gnInterface._setApplicationState(this.state_)}gnInterface._setResizeHandler(this.IframeResizeHandler.bind(this));gnInterface._setCloseHandler(this.IframeCloseHandler.bind(this));gnInterface._setGetCurrentPageHandler(this.IframeGetCurrentPageHandler.bind(this));gnInterface._setMaximizeHandler(this.IframeMaximizeHandler.bind(this));gnInterface._setOpenHandler(this.IframeOpenHandler.bind(this));gnInterface._selectionChanged(this.GetValidSelectionRange(this.watcher_.getCurrentWindow())!=null);return true}

;GNOTES_BrowserOverlay.prototype.IframeResizeHandler=function(w,h){var overlayStyle=this.GetOverlayElt_().style;overlayStyle.width=w+"px";overlayStyle.height=h+"px"}
;GNOTES_BrowserOverlay.prototype.IframeCloseHandler=function(){this.state_=null;this.HideBox_()}
;GNOTES_BrowserOverlay.prototype.IframeGetCurrentPageHandler=function(){return this.GetAddableDict_()}
;GNOTES_BrowserOverlay.prototype.IframeMaximizeHandler=function(url){var ifr=this.GetIframeElt_();if(ifr==null)return;this.NavigateUrl_(url);var gnInterface=this.GetInterfaceObj_(ifr);gnInterface._tryClose()}
;GNOTES_BrowserOverlay.prototype.IframeOpenHandler=function(url,way){this.NavigateUrl_(url,way)}
;GNOTES_BrowserOverlay.prototype.SetUpIframe_=function(ifr,cacheBreak){ifr.setAttribute("src",this.onpageUrl_+"?"+this.clientParam_+(cacheBreak?"&zx="+(new Date).getTime():""));ifr.addEventListener("load",this.IframeLoadCallback_.bind(this),true)}
;GNOTES_BrowserOverlay.prototype.NavigateUrl_=function(url,opt_way){if(!isDef(opt_way)||opt_way==null){opt_way=this.openNewWindow_==3?2:1}if(opt_way==0){var currentWindow=this.watcher_.getCurrentBrowser().contentWindow;currentWindow.location.href=url}else if(opt_way==1){this.win_.open(url)}else if(opt_way==2){this.watcher_.getTabBrowser().addTab(url)}return false}
;GNOTES_BrowserOverlay.prototype.AddEntry=function(body,title,url,opt_query,opt_attemptCount){var attemptCount=isDef(opt_attemptCount)?opt_attemptCount:0;if(attemptCount==0){this.ShowBox_()}var ifr=this.GetIframeElt_();var w=ifr.contentWindow;if(body!=null&&body.indexOf("<br>")==0){body=body.substring(4)}var gnInterface=this.GetInterfaceObj_(ifr);if(gnInterface!=null){w.setTimeout(function(){gnInterface._addNote(body,url,title,opt_query)}
,1)}else if(attemptCount<10){var self=this;this.win_.setTimeout(function(){self.AddEntry(body,title,url,opt_query,attemptCount+1)}
,100)}}
;GNOTES_BrowserOverlay.prototype.CheckBoxState_=function(){var t=this.GetOverlayElt_();if(!t.hidden){var p=t.parentNode;var ifr=this.GetIframeElt_();var gnInterface=this.GetInterfaceObj_(ifr);if(gnInterface!=null){this.state_=gnInterface._getApplicationState()}p.appendChild(t);this.SetUpIframe_(t.childNodes[0],false);this.PositionBox_()}}
;GNOTES_BrowserOverlay.prototype.PositionBox_=function(){var t=this.GetOverlayElt_();if(t.hidden){return}var currentBrowser=this.GetCurrentBrowser();var doc=currentBrowser.contentDocument;var bottomHeight=this.doc_.getElementById("status-bar").boxObject.height;t.style.bottom=bottomHeight+"px";var isMail=false;if(isMail){t.style.right="";t.style.left="0px"}else if(isDef(doc.body)){t.style.left="";t.style.right="20px"}}
;GNOTES_BrowserOverlay.prototype.ShowBox_=function(){var t=this.GetOverlayElt_();if(t.hidden){t.style.zIndex=1000;t.style.display="block";t.hidden=false;this.PositionBox_();this.SetStatusBarText_("Loading...");this.SetUpIframe_(this.GetIframeElt_(),true)}}
;GNOTES_BrowserOverlay.prototype.StatusCallback=function(event){if(event.button!=0){return true}if(this.GetOverlayElt_().hidden){this.ShowBox_()}else{var ifr=this.GetIframeElt_();var gnInterface=this.GetInterfaceObj_(ifr);if(gnInterface!=null){gnInterface._tryClose()}else{this.HideBox_()}}}
;GNOTES_BrowserOverlay.prototype.GetValidSelectionRange=function(win){var sel=win.getSelection();if(sel!=null&&sel.rangeCount>0){var range=sel.getRangeAt(sel.rangeCount-1);if(!this.WHITESPACE_REGEXP.test(sel.toString())&&sel.toString().length>5){return range.cloneRange()}var ca=range.commonAncestorContainer;if(ca!=null&&isDef(ca.getElementsByTagName)){var imgs=ca.getElementsByTagName("IMG");for(var i=0;i<imgs.length;++i){if(range.compareNode(imgs[i])==range.NODE_INSIDE){return range.cloneRange()}
}}}return null}
;GNOTES_BrowserOverlay.prototype.SerializeRange=function(doc,range){if(range==null||doc==null){return null}var renderingDiv=doc.createElement("div");renderingDiv.appendChild(range.cloneContents());return renderingDiv.innerHTML.replace(/^\s+|\s+$/g,"")}
;GNOTES_BrowserOverlay.prototype.NotifySelection=function(newState){var t=this.GetOverlayElt_();var ifr=this.GetIframeElt_();if(!t.hidden){var gnInterface=this.GetInterfaceObj_(ifr);if(gnInterface!=null){gnInterface._selectionChanged(newState)}}}
;GNOTES_BrowserOverlay.prototype.GetAddableDict_=function(){var browser=this.GetCurrentBrowser();var doc=browser.contentDocument;var win=browser.contentWindow;var selection=this.SerializeRange(doc,this.GetValidSelectionRange(win));if(selection==null){var contextMenu=this.win_.gContextMenu;if(contextMenu!=null){if(contextMenu.onImage){selection=this.MakeImageTag_(contextMenu.target)}else if(contextMenu.onLink){selection="<a href="+contextMenu.linkURL+">"+contextMenu.linkText()+"</a>"}else if(contextMenu.isTextSelected)
{selection=contextMenu.searchSelected()}}}var title=isString(doc.title)?doc.title:"";var url=win.location.href+"";if(title==null||title==""){title=url;title=title.substring(title.indexOf("//")+2)}return{_title:title,_url:url,_content:selection}}
;GNOTES_BrowserOverlay.prototype.NotifyGoogle_=function(win){var url=win.location.href;if(url.indexOf("https://www.google.com/accounts/ServiceLogin")==0){win.hasGnExt=true}if(url.indexOf("http://www.google.com/notebook")==0){win.hasGnExt=true}}
;GNOTES_BrowserOverlay.prototype.ContextCallback=function(event){var dict=this.GetAddableDict_();this.AddEntry(dict._content,dict._title,dict._url)}
;GNOTES_BrowserOverlay.prototype.TogglePlus=function(event){var newVal=this.doc_.getElementById("gnotes-enable-plus").getAttribute("checked");var newBool=newVal=="true";var showAddButton=this.prefs_.setBoolPref("addbutton",newBool);this.addButton_.SetShowButton(newBool)}
;GNOTES_BrowserOverlay.prototype.HideBox_=function(){var t=this.GetOverlayElt_();t.hidden=true;t.style.display="none";this.SetStatusBarText_("Open Notebook")}
;GNOTES_BrowserOverlay.prototype.OnPageLoad_=function(event){var win=event.browser.contentWindow;this.resultsPage_.AnnotateSearch(event);this.NotifyGoogle_(win);if(!this.GetOverlayElt_().hidden&&event.isTop&&event.inSelected){this.NotifySelection(this.GetValidSelectionRange(win)!=null);this.PositionBox_()}}
;GNOTES_BrowserOverlay.prototype.OnTabSwitch_=function(event){var t=this.GetOverlayElt_();if(!t.hidden){this.SetStatusBarText_("Loading...");if(this.tabTimer_!=null){this.win_.clearTimeout(this.tabTimer_)}this.tabTimer_=this.win_.setTimeout(this.CheckBoxState_.bind(this),500)}}
;GNOTES_BrowserOverlay.prototype.Init_=function(){this.contentArea_=this.doc_.getElementById("content");this.watcher_=new G_TabbedBrowserWatcher(this.contentArea_,"Gnotes");this.watcher_.registerListener("tabswitch",this.OnTabSwitch_.bind(this));this.watcher_.registerListener("load",this.OnPageLoad_.bind(this));this.addButton_=new GNOTES_AddButton(this,this.SERVER+"fullpage");this.contentArea_.addEventListener("mousedown",this.addButton_.OnMouseDown.bind(this.addButton_),true);this.contentArea_.addEventListener(
"mouseup",this.addButton_.OnMouseUp.bind(this.addButton_),true);this.contentArea_.addEventListener("click",this.addButton_.OnMouseClick.bind(this.addButton_),false);this.prefs_=new G_Preferences("extensions.google.gnotes.");this.onpageUrl_=this.prefs_.getPref("onpageurl",this.SERVER+"onpage");this.resultsPage_=new GNOTES_ResultsPage(this);var introVersion=this.prefs_.getPref("introversion",null);if(introVersion==null||introVersion==""||introVersion<1){this.prefs_.setPref("introversion","1");this.NavigateUrl_(
this.SERVER+"welcome/ff",0)}var showAddButton=this.prefs_.getBoolPrefOrDefault("addbutton",false);if(showAddButton){var menuItem=this.doc_.getElementById("gnotes-enable-plus");menuItem.setAttribute("checked","true");this.addButton_.SetShowButton(true)}else{this.addButton_.SetShowButton(false)}this.tabPrefs_=new G_Preferences("browser.link.");this.openNewWindow_=this.tabPrefs_.getPref("open_newwindow");this.overlayElt_=this.doc_.getElementById("gnotes-overlay");this.statusElt_=this.doc_.getElementById(
"gnotes-statusbar-lbl");this.state_=null;this.updater_=new G_ExtensionUpdater("notebook@google.com");this.updater_.UpdatePeriodically(false)}
;
;

